
import java.io.InputStream;
import java.io.OutputStream;

import java.io.FileNotFoundException;
import java.io.IOException;


public class SmartCard {
    private PersistentMemory persistentMem;

    private SmartCard(String stateFileName) 
                                   throws FileNotFoundException, IOException {
	persistentMem = new PersistentMemory(stateFileName);
    }
    
    private void execute(InputStream inStream, OutputStream outStream) 
                                                          throws IOException {
	// This method is executed when the smartcard is inserted into
        //    another device.  It continues to run until either (a) it
	//    returns, or (b) the other device ejects the smartcard.  
	//    Ejection is a brutal stop to this code--the code stops without
	//    warning, with no chance to save anything.  
	// The persistent memory of the card is available as persistentMem.
	//    Changes you make to persistentMem will not survive termination
	//    of this code, unless you call persistentMem.save().

	// IMPLEMENT THIS

	// This is a working but insecure implementation; you will need
	//     to modify or replace it.
	outStream.write(persistentMem.get(0));
	outStream.flush();
	byte inVal = (byte)(inStream.read());
	persistentMem.put(0, inVal);
	System.err.println("Enabled = " + (int)inVal);
	System.err.flush();

	// send a byte, to tell the other side that it's safe to eject us
	outStream.write((byte)0);
	outStream.flush();
    }

    public static void main(String[] args) 
                                   throws FileNotFoundException, IOException {
	// DON'T MODIFY THIS
	SmartCard card = new SmartCard(args[0]);
	card.execute(System.in, System.out);
    }
}
